Imports System
Imports System.Runtime.InteropServices
Imports System.Collections.Generic

Public Module uCalcNET
#If PLATFORM = "x64" Then
    Const uCalcDLL As String = "uCalc64.dll"
#Else
    Const uCalcDLL As String = "uCalc32.dll"
#End If

    Public Delegate Sub uCalcDelegate(ByVal Expr As IntPtr)


	
	

	

	Public Enum BuiltInTypesEnum As Int32
	Type_Unspecified
	Type_Auto
	Type_Boolean
	Type_Integer_8
	Type_Integer_8u
	Type_Integer_16
	Type_Integer_16u
	Type_Integer_32
	Type_Integer_32u
	Type_Integer_64
	Type_Integer_64u
	Type_Integer_128
	Type_Integer_128u
	Type_Float_Single
	Type_Float_Double
	Type_Float_Extended
	Type_Size_t
	Type_Complex
	Type_Decimal
	Type_BigNum
	Type_Date
	Type_String
	Type_String_LPCSTR
	Type_String_Fixed
	Type_String_Wide
	Type_List_Stack
	Type_List_Table
	Type_List_Sorted
	Type_Null
	Type_Void
	Type_Any
	Type_Pointer
	Type_Omni
	Type_UserDefined
	Type_Object
End Enum 

Public Enum ErrorHandlerResponseEnum As Int32
	ErrorAbort
	ErrorResume
	ErrorReRaise
End Enum

Public Enum ErrorNumberEnum As Int32
	Err_None
	Err_Dynamically_Defined
	Err_Syntax_Error
	Err_Undefined_Identifier
	Err_FileNotFound
	Err_Unrecognized_Token
	Err_Unrecognized_Command
	Err_Datatype_Mismatch
	Err_Invalid_Argument_Count
	Err_Invalid_Definition
	Err_CodeBlock_Error
	Err_Undefined_Callback
	Err_ErrorMessageAlreadyDefined
	Err_ItemCannotBeModified
	Err_Unrecognized_Class_Member
	Err_Unrecognized_Namespace_Member
	Err_Unbalanced_Quote
	Err_ValueCannotBeAssigned
	Err_Array_Bounds_Exceeded
	Err_Float_Division_By_Zero
	Err_Float_Inexact_Result
	Err_Float_Invalid_Operation
	Err_Float_Overflow
	Err_Float_Underflow
	Err_Customized1 = 100
	Err_Customized2
	Err_Customized3
	Err_Customized4
	Err_Customized5
	Err_Customized6
	Err_Customized7
	Err_Customized8
	Err_Customized9
	Err_Customized10
	Err_Customized11
	Err_Customized12
	Err_Customized13
	Err_Customized14
	Err_Customized15
	Err_Customized16
	Err_Customized17
	Err_Customized18
	Err_Customized19
	Err_Customized20
End Enum

Public Enum GroupingEnum As Int32
	GroupLeftToRight 
	GroupRightToLeft
End Enum

Public Enum ItemIsEnum As Int32
	LeftToRight
	RightToLeft
	DataType
	Array
	Class_
	Namespace_
	Variable
	LocalVariable
	Function_
	Operator_
	FunctionOrOperator
	Prefix
	Infix
	Postfix
	AddressOwner
	ByVal_
	ByRef_
	ByCopy
	ByExpr
	ByHandle
	IntPtr
	Optional_
	RegEx
	LiteralItem
	Locked
	Transform
	StdCall
	InTable
	ItemDef
	ErrorHandler
	StopNow
	CaseSensitive
	QuotedText
	ChangeMulti
	ExpandArg
	IgnoreStatementSep
	IgnoreCodeBlock
	SyntaxStop
	SkipEvalExpand
	ExprUnit
	EagerArg
	SkipSyntax
	WhiteSpaceCounts
	IgnoreQuote
	UpToEndOrSeparator
	UpToUserStop
	EvalStrOutput
	SkipOutput
	MiscItem
End Enum

Public Enum LicenseTypeEnum As Int32
	License_Demo
	License_FMP_Free
	License_FMP_Standard_32
	License_FMP_Standard_64
	License_FMP_32_and_64
	License_LanguageBuilder
	License_GeneralParser
	License_Interpreter
	License_ConsoleCalc
	License_WindowsCalc
	License_StringLib
	License_Transform
	License_TransformLib
	License_Search
	License_SearchLib
	License_Library1
	License_Library2
	License_Beta
	License_Debugger
	License_uCalc_All
	License_Developer
	License_EndUser
End Enum

Public Enum TokenEnum As Int32
	None
	Generic
	Empty
	AlphaNumeric
	ArgSeparator
	CodeBlock
	CodeBlockMatch
	MemberAccess
	Literal
	StatementSep
	WhiteSpace
	Reducible
	Eof
	CurrentThread
	LocalVar
	StaticVar
	DefineNow = StaticVar
	TempDef
	EvalInsert
	EvalDuringParse
	ExpandInsert
	FileInclude
	CurrentSpace
	DefSpace
	EvalSpace
End Enum

Public Enum TrueFalseEnum As Int32
	False_
	True_
End Enum

Public Enum FpuExceptionEnum As Int32
	Fpu_DivisionByZero = 8
	Fpu_Inexact = 1
	Fpu_Invalid = 16
	Fpu_Overflow = 4
	Fpu_Underflow = 2
	Fpu_AllExcept = 31
End Enum

Public Enum FpuRoundingEnum As Int32
	Fpu_Round_Down = 512
	Fpu_Round_ToNearest = 0
	Fpu_Round_TowardZero = 768
	Fpu_Round_Up = 256
End Enum

	<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Evaluate")> _ 
    Private Function Evaluate_(ByVal Handle As IntPtr) As  Double
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="EvaluateInt32")> _ 
    Private Function EvaluateInt32_(ByVal Handle As IntPtr) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="EvaluateStr")> _ 
    Private Function EvaluateStr_(ByVal Handle As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="EvaluateVoid")> _ 
    Private Function EvaluateVoid_(ByVal Handle As IntPtr) As  IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Execute")> _ 
    Private Sub Execute_(ByVal Handle As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReleaseExpr")> _ 
    Private Sub ReleaseExpr_(ByVal Handle As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ElementCount")> _ 
    Private Function ElementCount_(ByVal Handle As IntPtr) As  Int64
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="DataTypeHandle")> _ 
    Private Function DataTypeHandle_(ByVal Handle As IntPtr) As  IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="DataTypeIndex")> _ 
    Private Function DataTypeIndex_(ByVal Handle As IntPtr) As  BuiltInTypesEnum
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FunctionAddress")> _ 
    Private Function FunctionAddress_(ByVal Handle As IntPtr) As  IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="IsProperty")> _ 
    Private Function IsProperty_(ByVal Handle As IntPtr,ByVal ItemProperty As ItemIsEnum) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Name")> _ 
    Private Function Name_(ByVal Handle As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="NextHandle")> _ 
    Private Function NextHandle_(ByVal Handle As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Overload")> _ 
    Private Function Overload_(ByVal Handle As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Precedence")> _ 
    Private Function Precedence_(ByVal Handle As IntPtr) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReleaseItem")> _ 
    Private Sub ReleaseItem_(ByVal Handle As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReplacementText")> _ 
    Private Function ReplacementText_(ByVal Handle As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValue")> _ 
    Private Sub SetVariableValue_(ByVal Handle As IntPtr,ByVal Value As Double)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValue_Overload")> _ 
    Private Sub SetVariableValue_Overload_(ByVal Handle As IntPtr,ByVal Value As String)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValueInt8")> _ 
    Private Sub SetVariableValueInt8_(ByVal Handle As IntPtr,ByVal Value As Byte)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValueInt16")> _ 
    Private Sub SetVariableValueInt16_(ByVal Handle As IntPtr,ByVal Value As Int16)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValueInt32")> _ 
    Private Sub SetVariableValueInt32_(ByVal Handle As IntPtr,ByVal Value As Int32)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValueInt64")> _ 
    Private Sub SetVariableValueInt64_(ByVal Handle As IntPtr,ByVal Value As Int64)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValueSng")> _ 
    Private Sub SetVariableValueSng_(ByVal Handle As IntPtr,ByVal Value As Single)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValueDbl")> _ 
    Private Sub SetVariableValueDbl_(ByVal Handle As IntPtr,ByVal Value As Double)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValueStr")> _ 
    Private Sub SetVariableValueStr_(ByVal Handle As IntPtr,ByVal Value As String)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetVariableValuePtr")> _ 
    Private Sub SetVariableValuePtr_(ByVal Handle As IntPtr,ByVal Value As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Text")> _ 
    Private Function Text_(ByVal Handle As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Value")> _ 
    Private Function Value_(ByVal Handle As IntPtr) As  Double
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ValueDbl")> _ 
    Private Function ValueDbl_(ByVal Handle As IntPtr) As  Double
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ValueInt32")> _ 
    Private Function ValueInt32_(ByVal Handle As IntPtr) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ValuePtr")> _ 
    Private Function ValuePtr_(ByVal Handle As IntPtr) As  IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ValueStr")> _ 
    Private Function ValueStr_(ByVal Handle As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="VariableValue")> _ 
    Private Sub VariableValue_(ByVal Handle As IntPtr,ByVal Value As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Arg")> _ 
    Private Function Arg_(ByVal Expr As IntPtr,ByVal Index As Int32) As  Double
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ArgCount")> _ 
    Private Function ArgCount_(ByVal Expr As IntPtr) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ArgHandle")> _ 
    Private Function ArgHandle_(ByVal Expr As IntPtr,ByVal Index As Int32) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ArgExpr")> _ 
    Private Function ArgExpr_(ByVal Expr As IntPtr,ByVal Index As Int32) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ArgInt32")> _ 
    Private Function ArgInt32_(ByVal Expr As IntPtr,ByVal Index As Int32) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ArgInt64")> _ 
    Private Function ArgInt64_(ByVal Expr As IntPtr,ByVal Index As Int32) As  Int64
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ArgPtr")> _ 
    Private Function ArgPtr_(ByVal Expr As IntPtr,ByVal Index As Int32) As  IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ArgStr")> _ 
    Private Function ArgStr_(ByVal Expr As IntPtr,ByVal Index As Int32) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuRaiseException")> _ 
    Private Function FpuRaiseException_(ByVal Expr As IntPtr, ByVal Exception As FpuExceptionEnum ) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Return")> _ 
    Private Sub Return_(ByVal Expr As IntPtr,ByVal Value As Double)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReturnInt32")> _ 
    Private Sub ReturnInt32_(ByVal Expr As IntPtr,ByVal Value As Int32)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReturnInt64")> _ 
    Private Sub ReturnInt64_(ByVal Expr As IntPtr,ByVal Value As Int64)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReturnPtr")> _ 
    Private Sub ReturnPtr_(ByVal Expr As IntPtr,ByVal Value As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReturnStr")> _ 
    Private Sub ReturnStr_(ByVal Expr As IntPtr,ByVal Value As String)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorRaise")> _ 
    Private Function ErrorRaise_(ByVal Expr As IntPtr,ByVal ErrNumber As ErrorNumberEnum) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorRaiseMessage")> _ 
    Private Function ErrorRaiseMessage_(ByVal Expr As IntPtr,ByVal ErrMessage As String) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="RaiseErrorMessage")> _ 
    Private Function RaiseErrorMessage_(ByVal Expr As IntPtr,ByVal ErrMessage As String) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="AddErrorHandler")> _ 
    Private Function AddErrorHandler_(ByVal ucInstance As IntPtr,ByVal ErrorHandlerAddress As uCalcDelegate) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Create")> _ 
    Private Function Create_(ByVal ucInstance As IntPtr) As  IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Define")> _ 
    Private Function Define_(ByVal ucInstance As IntPtr,ByVal Expression As String,  ByVal Address As IntPtr ,  ByVal ExistingItem As IntPtr ) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="DefineFunction")> _ 
    Private Function DefineFunction_(ByVal ucInstance As IntPtr,ByVal Definition As String,  ByVal FunctionAddress As uCalcDelegate ) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="DefineOperator")> _ 
    Private Function DefineOperator_(ByVal ucInstance As IntPtr,ByVal Definition As String,  ByVal iPrecedence As Int32 ,  ByVal Grouping As GroupingEnum ,  ByVal FunctionAddress As uCalcDelegate ) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="DefineSyntax")> _ 
    Private Function DefineSyntax_(ByVal ucInstance As IntPtr,ByVal Definition As String) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="DefineTransform")> _ 
    Private Function DefineTransform_(ByVal ucInstance As IntPtr,ByVal FromExpr As String, ByVal ToExpr As String,  ByVal ItemHandle As IntPtr ) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="DefineVariable")> _ 
    Private Function DefineVariable_(ByVal ucInstance As IntPtr,ByVal Definition As String,  ByVal VariableAddress As IntPtr ) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorExpression")> _ 
    Private Function ErrorExpression_(ByVal ucInstance As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorLocation")> _ 
    Private Function ErrorLocation_(ByVal ucInstance As IntPtr) As  Int64
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorMessage")> _ 
    Private Function ErrorMessage_(ByVal ucInstance As IntPtr, ByVal Index As ErrorNumberEnum) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorNumber")> _ 
    Private Function ErrorNumber_(ByVal ucInstance As IntPtr) As  ErrorNumberEnum
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorResponse")> _ 
    Private Sub ErrorResponse_(ByVal ucInstance As IntPtr,ByVal Response As ErrorHandlerResponseEnum)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorSymbol")> _ 
    Private Function ErrorSymbol_(ByVal ucInstance As IntPtr) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ErrorSetExpression")> _ 
    Private Sub ErrorSetExpression_(ByVal ucInstance As IntPtr,ByVal Expression As String)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Eval")> _ 
    Private Function Eval_(ByVal ucInstance As IntPtr,ByVal Expression As String) As  Double
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="EvalStr")> _ 
    Private Function EvalStr_(ByVal ucInstance As IntPtr,ByVal Expression As String) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Expand")> _ 
    Private Function Expand_(ByVal ucInstance As IntPtr,ByVal Expression As String) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ExpandSteps")> _ 
    Private Function ExpandSteps_(ByVal ucInstance As IntPtr,ByVal Expression As String,  ByVal Separator As String) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuClearException")> _ 
    Private Function FpuClearException_(ByVal ucInstance As IntPtr, ByVal Exceptions As Int32 ) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuGetExceptionMask")> _ 
    Private Function FpuGetExceptionMask_(ByVal ucInstance As IntPtr) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuGetRounding")> _ 
    Private Function FpuGetRounding_(ByVal ucInstance As IntPtr) As  FpuRoundingEnum
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuSetExceptionMask")> _ 
    Private Sub FpuSetExceptionMask_(ByVal ucInstance As IntPtr,ByVal Exceptions As Int32)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuSetExceptionUnMask")> _ 
    Private Sub FpuSetExceptionUnMask_(ByVal ucInstance As IntPtr,ByVal Exceptions As Int32)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuSetRounding")> _ 
    Private Function FpuSetRounding_(ByVal ucInstance As IntPtr,ByVal Direction As FpuRoundingEnum) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="FpuToggleExceptionMask")> _ 
    Private Sub FpuToggleExceptionMask_(ByVal ucInstance As IntPtr,ByVal Exception As FpuExceptionEnum)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="HandleOf")> _ 
    Private Function HandleOf_(ByVal ucInstance As IntPtr,ByVal ItemName As String) As  IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="InstanceOf")> _ 
    Private Function InstanceOf_(ByVal ucInstance As IntPtr,ByVal ItemName As String) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ItemOf")> _ 
    Private Function ItemOf_(ByVal ucInstance As IntPtr,ByVal ItemName As String) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="License")> _ 
    Private Function License_(ByVal ucInstance As IntPtr,ByVal LicenseType As LicenseTypeEnum,  ByVal L1 As Int32 ,  ByVal L2 As Int32 ,  ByVal L3 As Int32 ,  ByVal L4 As Int32 ,  ByVal L5 As Int32 ) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Parse")> _ 
    Private Function Parse_(ByVal ucInstance As IntPtr,ByVal Expression As String,  ByVal DataType As String ) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="Precedence_Overload1")> _ 
    Private Function Precedence_Overload1_(ByVal ucInstance As IntPtr,ByVal Operator1 As String,  ByVal Operator2 As String ) As  Int32
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ReleaseuCalc")> _ 
    Private Sub ReleaseuCalc_(ByVal ucInstance As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="ResetOutput")> _ 
    Private Sub ResetOutput_(ByVal ucInstance As IntPtr)
End Sub
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetOutput")> _ 
    Private Function SetOutput_(ByVal ucInstance As IntPtr,ByVal FunctionAddress As uCalcDelegate, ByVal Definition As String) As IntPtr
    End Function
<DllImport(uCalcDLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl, EntryPoint:="SetOutput_Over_load")> _ 
    Private Function SetOutput_Over_load_(ByVal ucInstance As IntPtr,ByVal Definition As String) As IntPtr
    End Function


	Public Class uCalc
	    Public ucInstance As IntPtr 	
	
	Public Class ParsedExpr
	    Public Handle As IntPtr 
	
    Function Evaluate() As  Double
        Return Evaluate_(Handle)
    End Function
    	
    Function EvaluateInt32() As  Int32
        Return EvaluateInt32_(Handle)
    End Function
    	
    Function EvaluateStr() As String
        Return Marshal.PtrToStringAnsi(EvaluateStr_(Handle)) 
    End Function
    	
    Function EvaluateVoid() As  IntPtr
        Return EvaluateVoid_(Handle)
    End Function
    	
    Sub Execute()
         Execute_(Handle)
End Sub
    	
    Sub ReleaseExpr()
         ReleaseExpr_(Handle)
End Sub
    	    Public Sub Release()
        ReleaseExpr()
 Handle = Nothing 

    End Sub
	    Public Sub New()
        Handle = Nothing 

    End Sub
	    Public Sub New(ByVal ExprHandle As IntPtr)
        Handle = ExprHandle

    End Sub
	    Public Sub New(ByVal ParsedExprInstance As ParsedExpr)
        Handle = ParsedExprInstance.Handle

    End Sub
	End Class
	
	Public Class Item
	    Public Handle As IntPtr 
	
    Function ElementCount() As  Int64
        Return ElementCount_(Handle)
    End Function
    	
    Function DataTypeHandle() As  IntPtr
        Return DataTypeHandle_(Handle)
    End Function
    	
    Function DataTypeIndex() As  BuiltInTypesEnum
        Return DataTypeIndex_(Handle)
    End Function
    	
    Function FunctionAddress() As  IntPtr
        Return FunctionAddress_(Handle)
    End Function
    	
    Function IsProperty(ByVal ItemProperty As ItemIsEnum) As  Int32
        Return IsProperty_(Handle,ItemProperty)
    End Function
    	
    Function Name() As String
        Return Marshal.PtrToStringAnsi(Name_(Handle)) 
    End Function
    	
    Function NextHandle() As Item
   Return New Item(NextHandle_(Handle))
    End Function
    	
    Function Overload() As Item
   Return New Item(Overload_(Handle))
    End Function
    	
    Function Precedence() As  Int32
        Return Precedence_(Handle)
    End Function
    	
    Sub ReleaseItem()
         ReleaseItem_(Handle)
End Sub
    	
    Function ReplacementText() As String
        Return Marshal.PtrToStringAnsi(ReplacementText_(Handle)) 
    End Function
    	
    Sub SetVariableValue(ByVal Value As Double)
         SetVariableValue_(Handle,Value)
End Sub
    	
    Sub SetVariableValue(ByVal Value As String)
         SetVariableValue_Overload_(Handle,Value)
End Sub
    	
    Sub SetVariableValueInt8(ByVal Value As Byte)
         SetVariableValueInt8_(Handle,Value)
End Sub
    	
    Sub SetVariableValueInt16(ByVal Value As Int16)
         SetVariableValueInt16_(Handle,Value)
End Sub
    	
    Sub SetVariableValueInt32(ByVal Value As Int32)
         SetVariableValueInt32_(Handle,Value)
End Sub
    	
    Sub SetVariableValueInt64(ByVal Value As Int64)
         SetVariableValueInt64_(Handle,Value)
End Sub
    	
    Sub SetVariableValueSng(ByVal Value As Single)
         SetVariableValueSng_(Handle,Value)
End Sub
    	
    Sub SetVariableValueDbl(ByVal Value As Double)
         SetVariableValueDbl_(Handle,Value)
End Sub
    	
    Sub SetVariableValueStr(ByVal Value As String)
         SetVariableValueStr_(Handle,Value)
End Sub
    	
    Sub SetVariableValuePtr(ByVal Value As IntPtr)
         SetVariableValuePtr_(Handle,Value)
End Sub
    	
    Function Text() As String
        Return Marshal.PtrToStringAnsi(Text_(Handle)) 
    End Function
    	
    Function Value() As  Double
        Return Value_(Handle)
    End Function
    	
    Function ValueDbl() As  Double
        Return ValueDbl_(Handle)
    End Function
    	
    Function ValueInt32() As  Int32
        Return ValueInt32_(Handle)
    End Function
    	
    Function ValuePtr() As  IntPtr
        Return ValuePtr_(Handle)
    End Function
    	
    Function ValueStr() As String
        Return Marshal.PtrToStringAnsi(ValueStr_(Handle)) 
    End Function
    	
    Sub VariableValue(ByVal Value As IntPtr)
         VariableValue_(Handle,Value)
End Sub
    	    Public Sub Release()
        ReleaseItem()
 Handle = Nothing 

    End Sub
	    Public Sub New()
        Handle = Nothing 

    End Sub
	    Public Sub New(ByVal ItemHandle As IntPtr)
        Handle = ItemHandle

    End Sub
	    Public Sub New(ByVal ItemHandleInstance As Item)
        Handle = ItemHandleInstance.Handle

    End Sub
	End Class

	Public Class Callback
	    Public Expr As IntPtr 
	
    Function Arg(ByVal Index As Int32) As  Double
        Return Arg_(Expr,Index)
    End Function
    	
    Function ArgCount() As  Int32
        Return ArgCount_(Expr)
    End Function
    	
    Function ArgHandle(ByVal Index As Int32) As Item
   Return New Item(ArgHandle_(Expr,Index))
    End Function
    	
    Function ArgExpr(ByVal Index As Int32) As ParsedExpr
   Return New ParsedExpr(ArgExpr_(Expr,Index))
    End Function
    	
    Function ArgInt32(ByVal Index As Int32) As  Int32
        Return ArgInt32_(Expr,Index)
    End Function
    	
    Function ArgInt64(ByVal Index As Int32) As  Int64
        Return ArgInt64_(Expr,Index)
    End Function
    	
    Function ArgPtr(ByVal Index As Int32) As  IntPtr
        Return ArgPtr_(Expr,Index)
    End Function
    	
    Function ArgStr(ByVal Index As Int32) As String
        Return Marshal.PtrToStringAnsi(ArgStr_(Expr,Index)) 
    End Function
    	
	
    Function FpuRaiseException(Optional  ByVal Exception As FpuExceptionEnum = FpuExceptionEnum.Fpu_Invalid) As  Int32
        Return FpuRaiseException_(Expr,Exception)
    End Function
    	
    Sub ReturnDbl(ByVal Value As Double)
         Return_(Expr,Value)
End Sub
    	
    Sub ReturnInt32(ByVal Value As Int32)
         ReturnInt32_(Expr,Value)
End Sub
    	
    Sub ReturnInt64(ByVal Value As Int64)
         ReturnInt64_(Expr,Value)
End Sub
    	
    Sub ReturnPtr(ByVal Value As IntPtr)
         ReturnPtr_(Expr,Value)
End Sub
    	
    Sub ReturnStr(ByVal Value As String)
         ReturnStr_(Expr,Value)
End Sub
    	
    Function ErrorRaise(ByVal ErrNumber As ErrorNumberEnum) As  Int32
        Return ErrorRaise_(Expr,ErrNumber)
    End Function
    	
    Function ErrorRaiseMessage(ByVal ErrMessage As String) As  Int32
        Return ErrorRaiseMessage_(Expr,ErrMessage)
    End Function
    	
    Function RaiseErrorMessage(ByVal ErrMessage As String) As  Int32
        Return RaiseErrorMessage_(Expr,ErrMessage)
    End Function
    	    Public Sub New()
        Expr = Nothing 

    End Sub
	    Public Sub New(ByVal ExprHandle As IntPtr)
        Expr = ExprHandle

    End Sub
	    Public Sub New(ByVal ExprInstance As Callback)
        Expr = ExprInstance.Expr

    End Sub
	End Class

	
    Function AddErrorHandler(ByVal ErrorHandlerAddress As uCalcDelegate) As Item
   Return New Item(AddErrorHandler_(ucInstance,ErrorHandlerAddress))
    End Function
    	
    Function Create() As  IntPtr
        Return Create_(ucInstance)
    End Function
    	
    Function Define(ByVal Expression As String, Optional  ByVal Address As IntPtr = Nothing, Optional  ByVal ExistingItem As IntPtr = Nothing) As Item
   Return New Item(Define_(ucInstance,Expression, Address, ExistingItem))
    End Function
    	
    Function DefineFunction(ByVal Definition As String, Optional  ByVal FunctionAddress As uCalcDelegate = Nothing) As Item
   Return New Item(DefineFunction_(ucInstance,Definition, FunctionAddress))
    End Function
    	
    Function DefineOperator(ByVal Definition As String, Optional  ByVal iPrecedence As Int32 = 0, Optional  ByVal Grouping As GroupingEnum = GroupingEnum.GroupLeftToRight, Optional  ByVal FunctionAddress As uCalcDelegate = Nothing) As Item
   Return New Item(DefineOperator_(ucInstance,Definition, iPrecedence, Grouping, FunctionAddress))
    End Function
    	
    Function DefineSyntax(ByVal Definition As String) As Item
   Return New Item(DefineSyntax_(ucInstance,Definition))
    End Function
    	
    Function DefineTransform(ByVal FromExpr As String, ByVal ToExpr As String, Optional  ByVal ItemHandle As IntPtr = Nothing) As Item
   Return New Item(DefineTransform_(ucInstance,FromExpr, ToExpr, ItemHandle))
    End Function
    	
    Function DefineVariable(ByVal Definition As String, Optional  ByVal VariableAddress As IntPtr = Nothing) As Item
   Return New Item(DefineVariable_(ucInstance,Definition, VariableAddress))
    End Function
    	
    Function ErrorExpression() As String
        Return Marshal.PtrToStringAnsi(ErrorExpression_(ucInstance)) 
    End Function
    	
    Function ErrorLocation() As  Int64
        Return ErrorLocation_(ucInstance)
    End Function
    	
    Function ErrorMessage(Optional  ByVal Index As ErrorNumberEnum = ErrorNumberEnum.Err_None) As String
        Return Marshal.PtrToStringAnsi(ErrorMessage_(ucInstance,Index)) 
    End Function
    	
    Function ErrorNumber() As  ErrorNumberEnum
        Return ErrorNumber_(ucInstance)
    End Function
    	
    Sub ErrorResponse(ByVal Response As ErrorHandlerResponseEnum)
         ErrorResponse_(ucInstance,Response)
End Sub
    	
    Function ErrorSymbol() As String
        Return Marshal.PtrToStringAnsi(ErrorSymbol_(ucInstance)) 
    End Function
    	
    Sub ErrorSetExpression(ByVal Expression As String)
         ErrorSetExpression_(ucInstance,Expression)
End Sub
    	
    Function Eval(ByVal Expression As String) As  Double
        Return Eval_(ucInstance,Expression)
    End Function
    	
    Function EvalStr(ByVal Expression As String) As String
        Return Marshal.PtrToStringAnsi(EvalStr_(ucInstance,Expression)) 
    End Function
    	
    Function Expand(ByVal Expression As String) As String
        Return Marshal.PtrToStringAnsi(Expand_(ucInstance,Expression)) 
    End Function
    	
    Function ExpandSteps(ByVal Expression As String, Optional  ByVal Separator As String = "") As String
        Return Marshal.PtrToStringAnsi(ExpandSteps_(ucInstance,Expression, Separator)) 
    End Function
    	
    Function FpuClearException(Optional  ByVal Exceptions As Int32 = 0) As  Int32
        Return FpuClearException_(ucInstance,Exceptions)
    End Function
    	
    Function FpuGetExceptionMask() As  Int32
        Return FpuGetExceptionMask_(ucInstance)
    End Function
    	
    Function FpuGetRounding() As  FpuRoundingEnum
        Return FpuGetRounding_(ucInstance)
    End Function
    	
    Sub FpuSetExceptionMask(ByVal Exceptions As Int32)
         FpuSetExceptionMask_(ucInstance,Exceptions)
End Sub
    	
    Sub FpuSetExceptionUnMask(ByVal Exceptions As Int32)
         FpuSetExceptionUnMask_(ucInstance,Exceptions)
End Sub
    	
    Function FpuSetRounding(ByVal Direction As FpuRoundingEnum) As  Int32
        Return FpuSetRounding_(ucInstance,Direction)
    End Function
    	
    Sub FpuToggleExceptionMask(ByVal Exception As FpuExceptionEnum)
         FpuToggleExceptionMask_(ucInstance,Exception)
End Sub
    	
    Function HandleOf(ByVal ItemName As String) As  IntPtr
        Return HandleOf_(ucInstance,ItemName)
    End Function
    	
    Function InstanceOf(ByVal ItemName As String) As Item
   Return New Item(InstanceOf_(ucInstance,ItemName))
    End Function
    	
    Function ItemOf(ByVal ItemName As String) As Item
   Return New Item(ItemOf_(ucInstance,ItemName))
    End Function
    	
    Function License(ByVal LicenseType As LicenseTypeEnum, Optional  ByVal L1 As Int32 = 0, Optional  ByVal L2 As Int32 = 0, Optional  ByVal L3 As Int32 = 0, Optional  ByVal L4 As Int32 = 0, Optional  ByVal L5 As Int32 = 0) As  Int32
        Return License_(ucInstance,LicenseType, L1, L2, L3, L4, L5)
    End Function
    	
    Function Parse(ByVal Expression As String, Optional  ByVal DataType As String = "") As ParsedExpr
   Return New ParsedExpr(Parse_(ucInstance,Expression, DataType))
    End Function
    	
    Function Precedence(ByVal Operator1 As String, Optional  ByVal Operator2 As String = "") As  Int32
        Return Precedence_Overload1_(ucInstance,Operator1, Operator2)
    End Function
    	
    Sub ReleaseuCalc()
         ReleaseuCalc_(ucInstance)
End Sub
    	
    Sub ResetOutput()
         ResetOutput_(ucInstance)
End Sub
    	
    Function SetOutput(ByVal FunctionAddress As uCalcDelegate, ByVal Definition As String) As Item
   Return New Item(SetOutput_(ucInstance,FunctionAddress, Definition))
    End Function
    	
    Function SetOutput_Over_load(ByVal Definition As String) As Item
   Return New Item(SetOutput_Over_load_(ucInstance,Definition))
    End Function
    	    Public Sub Release()
        ReleaseuCalc()
 ucInstance = Nothing 

    End Sub
	    Public Sub Reset()
        ReleaseuCalc()
 ucInstance = Create()

    End Sub
	    Public Sub New()
        ucInstance = Nothing 
 ucInstance = Create()

    End Sub
	    Public Sub New(ByVal uCalcInstance As uCalc)
        ucInstance = uCalcInstance.ucInstance

    End Sub
	    Public Sub New(ByVal InstHandle As IntPtr)
        ucInstance = InstHandle

    End Sub
	    Public Sub New(ByVal LicenseType As LicenseTypeEnum, Optional  ByVal L1 As Int32 = 0, Optional  ByVal L2 As Int32 = 0, Optional  ByVal L3 As Int32 = 0, Optional  ByVal L4 As Int32 = 0, Optional  ByVal L5 As Int32 = 0)
        License(LicenseType, L1, L2, L3, L4, L5)
 ucInstance = Create()

    End Sub
	Public  Function Evaluate(ByVal Handle As IntPtr) As  Double
        Return Evaluate_(Handle)
    End Function
Public  Function EvaluateInt32(ByVal Handle As IntPtr) As  Int32
        Return EvaluateInt32_(Handle)
    End Function
Public  Function EvaluateStr(ByVal Handle As IntPtr) As String
        Return Marshal.PtrToStringAnsi(EvaluateStr_(Handle)) 
    End Function
Public  Function EvaluateVoid(ByVal Handle As IntPtr) As  IntPtr
        Return EvaluateVoid_(Handle)
    End Function
Public  Sub Execute(ByVal Handle As IntPtr)
         Execute_(Handle)
End Sub
Public  Sub ReleaseExpr(ByVal Handle As IntPtr)
         ReleaseExpr_(Handle)
End Sub
Public  Function ElementCount(ByVal Handle As IntPtr) As  Int64
        Return ElementCount_(Handle)
    End Function
Public  Function DataTypeHandle(ByVal Handle As IntPtr) As  IntPtr
        Return DataTypeHandle_(Handle)
    End Function
Public  Function DataTypeIndex(ByVal Handle As IntPtr) As  BuiltInTypesEnum
        Return DataTypeIndex_(Handle)
    End Function
Public  Function FunctionAddress(ByVal Handle As IntPtr) As  IntPtr
        Return FunctionAddress_(Handle)
    End Function
Public  Function IsProperty(ByVal Handle As IntPtr,ByVal ItemProperty As ItemIsEnum) As  Int32
        Return IsProperty_(Handle,ItemProperty)
    End Function
Public  Function Name(ByVal Handle As IntPtr) As String
        Return Marshal.PtrToStringAnsi(Name_(Handle)) 
    End Function
Public  Function NextHandle(ByVal Handle As IntPtr) As Item
   Return New Item(NextHandle_(Handle))
    End Function
Public  Function Overload(ByVal Handle As IntPtr) As Item
   Return New Item(Overload_(Handle))
    End Function
Public  Function Precedence(ByVal Handle As IntPtr) As  Int32
        Return Precedence_(Handle)
    End Function
Public  Sub ReleaseItem(ByVal Handle As IntPtr)
         ReleaseItem_(Handle)
End Sub
Public  Function ReplacementText(ByVal Handle As IntPtr) As String
        Return Marshal.PtrToStringAnsi(ReplacementText_(Handle)) 
    End Function
Public  Sub SetVariableValue(ByVal Handle As IntPtr,ByVal Value As Double)
         SetVariableValue_(Handle,Value)
End Sub
Public  Sub SetVariableValue(ByVal Handle As IntPtr,ByVal Value As String)
         SetVariableValue_Overload_(Handle,Value)
End Sub
Public  Sub SetVariableValueInt8(ByVal Handle As IntPtr,ByVal Value As Byte)
         SetVariableValueInt8_(Handle,Value)
End Sub
Public  Sub SetVariableValueInt16(ByVal Handle As IntPtr,ByVal Value As Int16)
         SetVariableValueInt16_(Handle,Value)
End Sub
Public  Sub SetVariableValueInt32(ByVal Handle As IntPtr,ByVal Value As Int32)
         SetVariableValueInt32_(Handle,Value)
End Sub
Public  Sub SetVariableValueInt64(ByVal Handle As IntPtr,ByVal Value As Int64)
         SetVariableValueInt64_(Handle,Value)
End Sub
Public  Sub SetVariableValueSng(ByVal Handle As IntPtr,ByVal Value As Single)
         SetVariableValueSng_(Handle,Value)
End Sub
Public  Sub SetVariableValueDbl(ByVal Handle As IntPtr,ByVal Value As Double)
         SetVariableValueDbl_(Handle,Value)
End Sub
Public  Sub SetVariableValueStr(ByVal Handle As IntPtr,ByVal Value As String)
         SetVariableValueStr_(Handle,Value)
End Sub
Public  Sub SetVariableValuePtr(ByVal Handle As IntPtr,ByVal Value As IntPtr)
         SetVariableValuePtr_(Handle,Value)
End Sub
Public  Function Text(ByVal Handle As IntPtr) As String
        Return Marshal.PtrToStringAnsi(Text_(Handle)) 
    End Function
Public  Function Value(ByVal Handle As IntPtr) As  Double
        Return Value_(Handle)
    End Function
Public  Function ValueDbl(ByVal Handle As IntPtr) As  Double
        Return ValueDbl_(Handle)
    End Function
Public  Function ValueInt32(ByVal Handle As IntPtr) As  Int32
        Return ValueInt32_(Handle)
    End Function
Public  Function ValuePtr(ByVal Handle As IntPtr) As  IntPtr
        Return ValuePtr_(Handle)
    End Function
Public  Function ValueStr(ByVal Handle As IntPtr) As String
        Return Marshal.PtrToStringAnsi(ValueStr_(Handle)) 
    End Function
Public  Sub VariableValue(ByVal Handle As IntPtr,ByVal Value As IntPtr)
         VariableValue_(Handle,Value)
End Sub
Public  Function Arg(ByVal Expr As IntPtr,ByVal Index As Int32) As  Double
        Return Arg_(Expr,Index)
    End Function
Public  Function ArgCount(ByVal Expr As IntPtr) As  Int32
        Return ArgCount_(Expr)
    End Function
Public  Function ArgHandle(ByVal Expr As IntPtr,ByVal Index As Int32) As Item
   Return New Item(ArgHandle_(Expr,Index))
    End Function
Public  Function ArgExpr(ByVal Expr As IntPtr,ByVal Index As Int32) As ParsedExpr
   Return New ParsedExpr(ArgExpr_(Expr,Index))
    End Function
Public  Function ArgInt32(ByVal Expr As IntPtr,ByVal Index As Int32) As  Int32
        Return ArgInt32_(Expr,Index)
    End Function
Public  Function ArgInt64(ByVal Expr As IntPtr,ByVal Index As Int32) As  Int64
        Return ArgInt64_(Expr,Index)
    End Function
Public  Function ArgPtr(ByVal Expr As IntPtr,ByVal Index As Int32) As  IntPtr
        Return ArgPtr_(Expr,Index)
    End Function
Public  Function ArgStr(ByVal Expr As IntPtr,ByVal Index As Int32) As String
        Return Marshal.PtrToStringAnsi(ArgStr_(Expr,Index)) 
    End Function
Public  Function FpuRaiseException(ByVal Expr As IntPtr, ByVal Exception As FpuExceptionEnum ) As  Int32
        Return FpuRaiseException_(Expr,Exception)
    End Function
Public  Sub ReturnDbl(ByVal Expr As IntPtr,ByVal Value As Double)
         Return_(Expr,Value)
End Sub
Public  Sub ReturnInt32(ByVal Expr As IntPtr,ByVal Value As Int32)
         ReturnInt32_(Expr,Value)
End Sub
Public  Sub ReturnInt64(ByVal Expr As IntPtr,ByVal Value As Int64)
         ReturnInt64_(Expr,Value)
End Sub
Public  Sub ReturnPtr(ByVal Expr As IntPtr,ByVal Value As IntPtr)
         ReturnPtr_(Expr,Value)
End Sub
Public  Sub ReturnStr(ByVal Expr As IntPtr,ByVal Value As String)
         ReturnStr_(Expr,Value)
End Sub
Public  Function ErrorRaise(ByVal Expr As IntPtr,ByVal ErrNumber As ErrorNumberEnum) As  Int32
        Return ErrorRaise_(Expr,ErrNumber)
    End Function
Public  Function ErrorRaiseMessage(ByVal Expr As IntPtr,ByVal ErrMessage As String) As  Int32
        Return ErrorRaiseMessage_(Expr,ErrMessage)
    End Function
Public  Function RaiseErrorMessage(ByVal Expr As IntPtr,ByVal ErrMessage As String) As  Int32
        Return RaiseErrorMessage_(Expr,ErrMessage)
    End Function
Public  Function AddErrorHandler(ByVal ErrorHandlerAddress As uCalcDelegate,ByVal ucInstance As IntPtr) As Item
   Return New Item(AddErrorHandler_(ucInstance,ErrorHandlerAddress))
    End Function
Public  Function Create(ByVal ucInstance As IntPtr) As  IntPtr
        Return Create_(ucInstance)
    End Function
Public  Function Define(ByVal Expression As String,  ByVal Address As IntPtr ,  ByVal ExistingItem As IntPtr ,ByVal ucInstance As IntPtr) As Item
   Return New Item(Define_(ucInstance,Expression, Address, ExistingItem))
    End Function
Public  Function DefineFunction(ByVal Definition As String,  ByVal FunctionAddress As uCalcDelegate ,ByVal ucInstance As IntPtr) As Item
   Return New Item(DefineFunction_(ucInstance,Definition, FunctionAddress))
    End Function
Public  Function DefineOperator(ByVal Definition As String,  ByVal iPrecedence As Int32 ,  ByVal Grouping As GroupingEnum ,  ByVal FunctionAddress As uCalcDelegate ,ByVal ucInstance As IntPtr) As Item
   Return New Item(DefineOperator_(ucInstance,Definition, iPrecedence, Grouping, FunctionAddress))
    End Function
Public  Function DefineSyntax(ByVal Definition As String,ByVal ucInstance As IntPtr) As Item
   Return New Item(DefineSyntax_(ucInstance,Definition))
    End Function
Public  Function DefineTransform(ByVal FromExpr As String, ByVal ToExpr As String,  ByVal ItemHandle As IntPtr ,ByVal ucInstance As IntPtr) As Item
   Return New Item(DefineTransform_(ucInstance,FromExpr, ToExpr, ItemHandle))
    End Function
Public  Function DefineVariable(ByVal Definition As String,  ByVal VariableAddress As IntPtr ,ByVal ucInstance As IntPtr) As Item
   Return New Item(DefineVariable_(ucInstance,Definition, VariableAddress))
    End Function
Public  Function ErrorExpression(ByVal ucInstance As IntPtr) As String
        Return Marshal.PtrToStringAnsi(ErrorExpression_(ucInstance)) 
    End Function
Public  Function ErrorLocation(ByVal ucInstance As IntPtr) As  Int64
        Return ErrorLocation_(ucInstance)
    End Function
Public  Function ErrorMessage( ByVal Index As ErrorNumberEnum ,ByVal ucInstance As IntPtr) As String
        Return Marshal.PtrToStringAnsi(ErrorMessage_(ucInstance,Index)) 
    End Function
Public  Function ErrorNumber(ByVal ucInstance As IntPtr) As  ErrorNumberEnum
        Return ErrorNumber_(ucInstance)
    End Function
Public  Sub ErrorResponse(ByVal Response As ErrorHandlerResponseEnum,ByVal ucInstance As IntPtr)
         ErrorResponse_(ucInstance,Response)
End Sub
Public  Function ErrorSymbol(ByVal ucInstance As IntPtr) As String
        Return Marshal.PtrToStringAnsi(ErrorSymbol_(ucInstance)) 
    End Function
Public  Sub ErrorSetExpression(ByVal Expression As String,ByVal ucInstance As IntPtr)
         ErrorSetExpression_(ucInstance,Expression)
End Sub
Public  Function Eval(ByVal Expression As String,ByVal ucInstance As IntPtr) As  Double
        Return Eval_(ucInstance,Expression)
    End Function
Public  Function EvalStr(ByVal Expression As String,ByVal ucInstance As IntPtr) As String
        Return Marshal.PtrToStringAnsi(EvalStr_(ucInstance,Expression)) 
    End Function
Public  Function Expand(ByVal Expression As String,ByVal ucInstance As IntPtr) As String
        Return Marshal.PtrToStringAnsi(Expand_(ucInstance,Expression)) 
    End Function
Public  Function ExpandSteps(ByVal Expression As String,  ByVal Separator As String ,ByVal ucInstance As IntPtr) As String
        Return Marshal.PtrToStringAnsi(ExpandSteps_(ucInstance,Expression, Separator)) 
    End Function
Public  Function FpuClearException( ByVal Exceptions As Int32 ,ByVal ucInstance As IntPtr) As  Int32
        Return FpuClearException_(ucInstance,Exceptions)
    End Function
Public  Function FpuGetExceptionMask(ByVal ucInstance As IntPtr) As  Int32
        Return FpuGetExceptionMask_(ucInstance)
    End Function
Public  Function FpuGetRounding(ByVal ucInstance As IntPtr) As  FpuRoundingEnum
        Return FpuGetRounding_(ucInstance)
    End Function
Public  Sub FpuSetExceptionMask(ByVal Exceptions As Int32,ByVal ucInstance As IntPtr)
         FpuSetExceptionMask_(ucInstance,Exceptions)
End Sub
Public  Sub FpuSetExceptionUnMask(ByVal Exceptions As Int32,ByVal ucInstance As IntPtr)
         FpuSetExceptionUnMask_(ucInstance,Exceptions)
End Sub
Public  Function FpuSetRounding(ByVal Direction As FpuRoundingEnum,ByVal ucInstance As IntPtr) As  Int32
        Return FpuSetRounding_(ucInstance,Direction)
    End Function
Public  Sub FpuToggleExceptionMask(ByVal Exception As FpuExceptionEnum,ByVal ucInstance As IntPtr)
         FpuToggleExceptionMask_(ucInstance,Exception)
End Sub
Public  Function HandleOf(ByVal ItemName As String,ByVal ucInstance As IntPtr) As  IntPtr
        Return HandleOf_(ucInstance,ItemName)
    End Function
Public  Function InstanceOf(ByVal ItemName As String,ByVal ucInstance As IntPtr) As Item
   Return New Item(InstanceOf_(ucInstance,ItemName))
    End Function
Public  Function ItemOf(ByVal ItemName As String,ByVal ucInstance As IntPtr) As Item
   Return New Item(ItemOf_(ucInstance,ItemName))
    End Function
Public  Function License(ByVal LicenseType As LicenseTypeEnum,  ByVal L1 As Int32 ,  ByVal L2 As Int32 ,  ByVal L3 As Int32 ,  ByVal L4 As Int32 ,  ByVal L5 As Int32 ,ByVal ucInstance As IntPtr) As  Int32
        Return License_(ucInstance,LicenseType, L1, L2, L3, L4, L5)
    End Function
Public  Function Parse(ByVal Expression As String,  ByVal DataType As String ,ByVal ucInstance As IntPtr) As ParsedExpr
   Return New ParsedExpr(Parse_(ucInstance,Expression, DataType))
    End Function
Public  Function Precedence(ByVal Operator1 As String,  ByVal Operator2 As String ,ByVal ucInstance As IntPtr) As  Int32
        Return Precedence_Overload1_(ucInstance,Operator1, Operator2)
    End Function
Public  Sub ReleaseuCalc(ByVal ucInstance As IntPtr)
         ReleaseuCalc_(ucInstance)
End Sub
Public  Sub ResetOutput(ByVal ucInstance As IntPtr)
         ResetOutput_(ucInstance)
End Sub
Public  Function SetOutput(ByVal FunctionAddress As uCalcDelegate, ByVal Definition As String,ByVal ucInstance As IntPtr) As Item
   Return New Item(SetOutput_(ucInstance,FunctionAddress, Definition))
    End Function
Public  Function SetOutput_Over_load(ByVal Definition As String,ByVal ucInstance As IntPtr) As Item
   Return New Item(SetOutput_Over_load_(ucInstance,Definition))
    End Function

Function PinAddr(ByVal Address As uCalcDelegate) As uCalcDelegate
   Static Addresses As New List(Of uCalcDelegate)
   Addresses.Add(Address)
   Return Address
End Function
End Class ' uCalc

	

	

	

	

	

Public uc As New uCalc

' The following items are deprecated but preserved for compatibility
' Change AllowDeprecated to True if you want to use these routines
#Const AllowDeprecated = True
#If AllowDeprecated = True

Function ucEvaluate(ByVal Handle As IntPtr) As  Double
    Return uc.Evaluate(Handle)
End Function

Function ucEvaluateInt32(ByVal Handle As IntPtr) As  Int32
    Return uc.EvaluateInt32(Handle)
End Function

Function ucEvaluateStr(ByVal Handle As IntPtr) As  String
    Return uc.EvaluateStr(Handle)
End Function

Function ucEvaluateVoid(ByVal Handle As IntPtr) As  IntPtr
    Return uc.EvaluateVoid(Handle)
End Function

Sub ucExecute(ByVal Handle As IntPtr)
     uc.Execute(Handle)
End Sub

Sub ucReleaseExpr(ByVal Handle As IntPtr)
     uc.ReleaseExpr(Handle)
End Sub

Function ucElementCount(ByVal Handle As IntPtr) As  Int64
    Return uc.ElementCount(Handle)
End Function

Function ucDataTypeHandle(ByVal Handle As IntPtr) As  IntPtr
    Return uc.DataTypeHandle(Handle)
End Function

Function ucDataTypeIndex(ByVal Handle As IntPtr) As  BuiltInTypesEnum
    Return uc.DataTypeIndex(Handle)
End Function

Function ucFunctionAddress(ByVal Handle As IntPtr) As  IntPtr
    Return uc.FunctionAddress(Handle)
End Function

Function ucIsProperty(ByVal Handle As IntPtr,ByVal ItemProperty As ItemIsEnum) As  Int32
    Return uc.IsProperty(Handle,ItemProperty)
End Function

Function ucName(ByVal Handle As IntPtr) As  String
    Return uc.Name(Handle)
End Function

Function ucNextHandle(ByVal Handle As IntPtr) As IntPtr
   Return New uCalc.Item(uc.NextHandle(Handle)).Handle
End Function

Function ucOverload(ByVal Handle As IntPtr) As IntPtr
   Return New uCalc.Item(uc.Overload(Handle)).Handle
End Function

Function ucPrecedence(ByVal Handle As IntPtr) As  Int32
    Return uc.Precedence(Handle)
End Function

Sub ucReleaseItem(ByVal Handle As IntPtr)
     uc.ReleaseItem(Handle)
End Sub

Function ucReplacementText(ByVal Handle As IntPtr) As  String
    Return uc.ReplacementText(Handle)
End Function

Sub ucSetVariableValue(ByVal Handle As IntPtr,ByVal Value As Double)
     uc.SetVariableValue(Handle,Value)
End Sub

Sub ucSetVariableValue(ByVal Handle As IntPtr,ByVal Value As String)
     uc.SetVariableValue(Handle,Value)
End Sub

Sub ucSetVariableValueInt8(ByVal Handle As IntPtr,ByVal Value As Byte)
     uc.SetVariableValueInt8(Handle,Value)
End Sub

Sub ucSetVariableValueInt16(ByVal Handle As IntPtr,ByVal Value As Int16)
     uc.SetVariableValueInt16(Handle,Value)
End Sub

Sub ucSetVariableValueInt32(ByVal Handle As IntPtr,ByVal Value As Int32)
     uc.SetVariableValueInt32(Handle,Value)
End Sub

Sub ucSetVariableValueInt64(ByVal Handle As IntPtr,ByVal Value As Int64)
     uc.SetVariableValueInt64(Handle,Value)
End Sub

Sub ucSetVariableValueSng(ByVal Handle As IntPtr,ByVal Value As Single)
     uc.SetVariableValueSng(Handle,Value)
End Sub

Sub ucSetVariableValueDbl(ByVal Handle As IntPtr,ByVal Value As Double)
     uc.SetVariableValueDbl(Handle,Value)
End Sub

Sub ucSetVariableValueStr(ByVal Handle As IntPtr,ByVal Value As String)
     uc.SetVariableValueStr(Handle,Value)
End Sub

Sub ucSetVariableValuePtr(ByVal Handle As IntPtr,ByVal Value As IntPtr)
     uc.SetVariableValuePtr(Handle,Value)
End Sub

Function ucText(ByVal Handle As IntPtr) As  String
    Return uc.Text(Handle)
End Function

Function ucValue(ByVal Handle As IntPtr) As  Double
    Return uc.Value(Handle)
End Function

Function ucValueDbl(ByVal Handle As IntPtr) As  Double
    Return uc.ValueDbl(Handle)
End Function

Function ucValueInt32(ByVal Handle As IntPtr) As  Int32
    Return uc.ValueInt32(Handle)
End Function

Function ucValuePtr(ByVal Handle As IntPtr) As  IntPtr
    Return uc.ValuePtr(Handle)
End Function

Function ucValueStr(ByVal Handle As IntPtr) As  String
    Return uc.ValueStr(Handle)
End Function

Sub ucVariableValue(ByVal Handle As IntPtr,ByVal Value As IntPtr)
     uc.VariableValue(Handle,Value)
End Sub

Function ucArg(ByVal Expr As IntPtr,ByVal Index As Int32) As  Double
    Return uc.Arg(Expr,Index)
End Function

Function ucArgCount(ByVal Expr As IntPtr) As  Int32
    Return uc.ArgCount(Expr)
End Function

Function ucArgHandle(ByVal Expr As IntPtr,ByVal Index As Int32) As IntPtr
   Return New uCalc.Item(uc.ArgHandle(Expr,Index)).Handle
End Function

Function ucArgExpr(ByVal Expr As IntPtr,ByVal Index As Int32) As IntPtr
   Return New uCalc.ParsedExpr(uc.ArgExpr(Expr,Index)).Handle
End Function

Function ucArgInt32(ByVal Expr As IntPtr,ByVal Index As Int32) As  Int32
    Return uc.ArgInt32(Expr,Index)
End Function

Function ucArgInt64(ByVal Expr As IntPtr,ByVal Index As Int32) As  Int64
    Return uc.ArgInt64(Expr,Index)
End Function

Function ucArgPtr(ByVal Expr As IntPtr,ByVal Index As Int32) As  IntPtr
    Return uc.ArgPtr(Expr,Index)
End Function

Function ucArgStr(ByVal Expr As IntPtr,ByVal Index As Int32) As  String
    Return uc.ArgStr(Expr,Index)
End Function

Function ucFpuRaiseException(ByVal Expr As IntPtr,Optional  ByVal Exception As FpuExceptionEnum = FpuExceptionEnum.Fpu_Invalid) As  Int32
    Return uc.FpuRaiseException(Expr,Exception)
End Function

Sub ucReturn(ByVal Expr As IntPtr,ByVal Value As Double)
     uc.ReturnDbl(Expr,Value)
End Sub

Sub ucReturnInt32(ByVal Expr As IntPtr,ByVal Value As Int32)
     uc.ReturnInt32(Expr,Value)
End Sub

Sub ucReturnInt64(ByVal Expr As IntPtr,ByVal Value As Int64)
     uc.ReturnInt64(Expr,Value)
End Sub

Sub ucReturnPtr(ByVal Expr As IntPtr,ByVal Value As IntPtr)
     uc.ReturnPtr(Expr,Value)
End Sub

Sub ucReturnStr(ByVal Expr As IntPtr,ByVal Value As String)
     uc.ReturnStr(Expr,Value)
End Sub

Function ucErrorRaise(ByVal Expr As IntPtr,ByVal ErrNumber As ErrorNumberEnum) As  Int32
    Return uc.ErrorRaise(Expr,ErrNumber)
End Function

Function ucErrorRaiseMessage(ByVal Expr As IntPtr,ByVal ErrMessage As String) As  Int32
    Return uc.ErrorRaiseMessage(Expr,ErrMessage)
End Function

Function ucRaiseErrorMessage(ByVal Expr As IntPtr,ByVal ErrMessage As String) As  Int32
    Return uc.RaiseErrorMessage(Expr,ErrMessage)
End Function

Function ucAddErrorHandler(ByVal ErrorHandlerAddress As uCalcDelegate,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.AddErrorHandler(ErrorHandlerAddress,ucInstance)).Handle
End Function

Function ucCreate(Optional  ByVal ucInstance As IntPtr = Nothing) As  IntPtr
    Return uc.Create(ucInstance)
End Function

Function ucDefine(ByVal Expression As String, Optional  ByVal Address As IntPtr = Nothing, Optional  ByVal ExistingItem As IntPtr = Nothing,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.Define(Expression, Address, ExistingItem,ucInstance)).Handle
End Function

Function ucDefineFunction(ByVal Definition As String, Optional  ByVal FunctionAddress As uCalcDelegate = Nothing,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.DefineFunction(Definition, FunctionAddress,ucInstance)).Handle
End Function

Function ucDefineOperator(ByVal Definition As String, Optional  ByVal iPrecedence As Int32 = 0, Optional  ByVal Grouping As GroupingEnum = GroupingEnum.GroupLeftToRight, Optional  ByVal FunctionAddress As uCalcDelegate = Nothing,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.DefineOperator(Definition, iPrecedence, Grouping, FunctionAddress,ucInstance)).Handle
End Function

Function ucDefineSyntax(ByVal Definition As String,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.DefineSyntax(Definition,ucInstance)).Handle
End Function

Function ucDefineTransform(ByVal FromExpr As String, ByVal ToExpr As String, Optional  ByVal ItemHandle As IntPtr = Nothing,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.DefineTransform(FromExpr, ToExpr, ItemHandle,ucInstance)).Handle
End Function

Function ucDefineVariable(ByVal Definition As String, Optional  ByVal VariableAddress As IntPtr = Nothing,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.DefineVariable(Definition, VariableAddress,ucInstance)).Handle
End Function

Function ucErrorExpression(Optional  ByVal ucInstance As IntPtr = Nothing) As  String
    Return uc.ErrorExpression(ucInstance)
End Function

Function ucErrorLocation(Optional  ByVal ucInstance As IntPtr = Nothing) As  Int64
    Return uc.ErrorLocation(ucInstance)
End Function

Function ucErrorMessage(Optional  ByVal Index As ErrorNumberEnum = ErrorNumberEnum.Err_None,Optional  ByVal ucInstance As IntPtr = Nothing) As  String
    Return uc.ErrorMessage(Index,ucInstance)
End Function

Function ucErrorNumber(Optional  ByVal ucInstance As IntPtr = Nothing) As  ErrorNumberEnum
    Return uc.ErrorNumber(ucInstance)
End Function

Sub ucErrorResponse(ByVal Response As ErrorHandlerResponseEnum,Optional  ByVal ucInstance As IntPtr = Nothing)
     uc.ErrorResponse(Response,ucInstance)
End Sub

Function ucErrorSymbol(Optional  ByVal ucInstance As IntPtr = Nothing) As  String
    Return uc.ErrorSymbol(ucInstance)
End Function

Sub ucErrorSetExpression(ByVal Expression As String,Optional  ByVal ucInstance As IntPtr = Nothing)
     uc.ErrorSetExpression(Expression,ucInstance)
End Sub

Function ucEval(ByVal Expression As String,Optional  ByVal ucInstance As IntPtr = Nothing) As  Double
    Return uc.Eval(Expression,ucInstance)
End Function

Function ucEvalStr(ByVal Expression As String,Optional  ByVal ucInstance As IntPtr = Nothing) As  String
    Return uc.EvalStr(Expression,ucInstance)
End Function

Function ucExpand(ByVal Expression As String,Optional  ByVal ucInstance As IntPtr = Nothing) As  String
    Return uc.Expand(Expression,ucInstance)
End Function

Function ucExpandSteps(ByVal Expression As String, Optional  ByVal Separator As String = "",Optional  ByVal ucInstance As IntPtr = Nothing) As  String
    Return uc.ExpandSteps(Expression, Separator,ucInstance)
End Function

Function ucFpuClearException(Optional  ByVal Exceptions As Int32 = 0,Optional  ByVal ucInstance As IntPtr = Nothing) As  Int32
    Return uc.FpuClearException(Exceptions,ucInstance)
End Function

Function ucFpuGetExceptionMask(Optional  ByVal ucInstance As IntPtr = Nothing) As  Int32
    Return uc.FpuGetExceptionMask(ucInstance)
End Function

Function ucFpuGetRounding(Optional  ByVal ucInstance As IntPtr = Nothing) As  FpuRoundingEnum
    Return uc.FpuGetRounding(ucInstance)
End Function

Sub ucFpuSetExceptionMask(ByVal Exceptions As Int32,Optional  ByVal ucInstance As IntPtr = Nothing)
     uc.FpuSetExceptionMask(Exceptions,ucInstance)
End Sub

Sub ucFpuSetExceptionUnMask(ByVal Exceptions As Int32,Optional  ByVal ucInstance As IntPtr = Nothing)
     uc.FpuSetExceptionUnMask(Exceptions,ucInstance)
End Sub

Function ucFpuSetRounding(ByVal Direction As FpuRoundingEnum,Optional  ByVal ucInstance As IntPtr = Nothing) As  Int32
    Return uc.FpuSetRounding(Direction,ucInstance)
End Function

Sub ucFpuToggleExceptionMask(ByVal Exception As FpuExceptionEnum,Optional  ByVal ucInstance As IntPtr = Nothing)
     uc.FpuToggleExceptionMask(Exception,ucInstance)
End Sub

Function ucHandleOf(ByVal ItemName As String,Optional  ByVal ucInstance As IntPtr = Nothing) As  IntPtr
    Return uc.HandleOf(ItemName,ucInstance)
End Function

Function ucInstanceOf(ByVal ItemName As String,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.InstanceOf(ItemName,ucInstance)).Handle
End Function

Function ucItemOf(ByVal ItemName As String,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.ItemOf(ItemName,ucInstance)).Handle
End Function

Function ucLicense(ByVal LicenseType As LicenseTypeEnum, Optional  ByVal L1 As Int32 = 0, Optional  ByVal L2 As Int32 = 0, Optional  ByVal L3 As Int32 = 0, Optional  ByVal L4 As Int32 = 0, Optional  ByVal L5 As Int32 = 0,Optional  ByVal ucInstance As IntPtr = Nothing) As  Int32
    Return uc.License(LicenseType, L1, L2, L3, L4, L5,ucInstance)
End Function

Function ucParse(ByVal Expression As String, Optional  ByVal DataType As String = "",Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.ParsedExpr(uc.Parse(Expression, DataType,ucInstance)).Handle
End Function

Function ucPrecedence(ByVal Operator1 As String, Optional  ByVal Operator2 As String = "",Optional  ByVal ucInstance As IntPtr = Nothing) As  Int32
    Return uc.Precedence(Operator1, Operator2,ucInstance)
End Function

Sub ucReleaseuCalc(Optional  ByVal ucInstance As IntPtr = Nothing)
     uc.ReleaseuCalc(ucInstance)
End Sub

Sub ucResetOutput(Optional  ByVal ucInstance As IntPtr = Nothing)
     uc.ResetOutput(ucInstance)
End Sub

Function ucSetOutput(ByVal FunctionAddress As uCalcDelegate, ByVal Definition As String,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.SetOutput(FunctionAddress, Definition,ucInstance)).Handle
End Function

Function ucSetOutput_Over_load(ByVal Definition As String,Optional  ByVal ucInstance As IntPtr = Nothing) As IntPtr
   Return New uCalc.Item(uc.SetOutput_Over_load(Definition,ucInstance)).Handle
End Function

#End If
End Module